/*	Specialities of GridText as subclass of HText
**      
**      This file has been modified for use with tkWWW
*/
#include "HText.h"		/* Superclass */
#include "HTChunk.h"
#include "HTStream.h"

#ifdef SHORT_NAMES
#define HText_childNumber		HTGTChNu
#define HText_sourceAnchors		HTGTSoAn
#define HText_getSource                 HTGTGeSo
#define HText_setSource                 HTGTSeSo
#define HText_appendBullet              HTGTApBu
#define HText_addAnchor                 HTGTAdAn
#endif

extern HTChildAnchor * HText_childNumber PARAMS((HText * text, int n));
extern int HText_sourceAnchors PARAMS((HText * text));
extern CONST char * HText_getSource PARAMS((HText *));
extern void HText_setSource PARAMS ((HText *, CONST char *));
extern void HText_appendBullet PARAMS ((HText *, CONST char *, BOOL));
extern int HText_addAnchor PARAMS((HText *text, HTChildAnchor *));
extern void HText_setAnchorHref PARAMS((HText *text, CONST char *));
extern CONST char * HText_getAnchorHref  PARAMS((HText * text, int n));

typedef struct _TextAnchor {
	struct _TextAnchor *	next;
	int			number;		/* For user interface */
	int			start;		/* Characters */
	int			extent;		/* Characters */
	HTChunk *               href;
	HTChildAnchor *		anchor;
} TextAnchor;

/*	Notes on struct _Htext:
**	next_line is valid iff state is false.
**	top_of_screen line means the line at the top of the screen
**			or just under the title if there is one.
*/
struct _HText {
	HTParentAnchor *	node_anchor;
	char *			title;
	int			lines;		/* Number of them */
	int			chars;		/* Number of them */
	TextAnchor *		first_anchor;	/* Singly linked list */
	TextAnchor *		last_anchor;
	int			last_anchor_number;	/* user number */
	char *                  source;
	HTChunk *               output;
	HTChunk *               current_line;
/* For Internal use: */	
	HTStyle *		style;			/* Current style */
        /* Number of spaces to offset current line */
	int                     offset;
        /* Number of printable characters in current line */
	int                     line_position;
	int			permissible_split;	/* in last line */
	int                     split_line_position;
	BOOL			in_line_1;		/* of paragraph */
	/* Running count of blank space */
	int                     blank_space;
	HTStream*		target;			/* Output stream */
	HTStreamClass		targetClass;		/* Output routines */
	int                     current_anchor;
	int                     line_begin_anchor;
	HTStyle *               line_begin_style;
	int                     in_command_mode;
};

