## annotation.tcl: Procedures for handling annotations
## ================
## Copyright (C) 1993 Joseph Wang
## See the file COPYRIGHT for conditions
##
## The format of the annotations is that of Xmosaic by Marc Andersen

## Add annotation
proc tkWWWAnnotateAdd {} {
    set w .annotate_dialog
    set address [tkWWWNavigateGetAddress]
    tkWWWAnnotateCreateEditor $w "
tkWWWPanNewPan $address \[DLG:get_entry_value $w 2\] \
 \[DLG:get_entry_value $w 1\] \[$w.text get 0.0 end\]
tkWWWConfigDisplay" ""
    set author [exec whoami]
    DLG:set_entry_value .annotate_dialog 1 $author 
    DLG:set_entry_value .annotate_dialog 2 "Annotation by $author"
    DLG:show . .annotate_dialog
}

## Edit annotation
proc tkWWWAnnotateEdit {} {
    set w .annotate_dialog
    set address [tkWWWNavigateGetAddress]
    if {[tkWWWPanIsEditablePan $address]} {
	set list [tkWWWPanGrokPanPieces $address]
	tkWWWAnnotateCreateEditor $w "
tkWWWPanModifyPan [lindex $list 0] \[DLG:get_entry_value $w 2\]\
   \[DLG:get_entry_value $w 1\] \[$w.text get 0.0 end\]
tkWWWNavigateUncache $address
tkWWWNavigateGoto $address" "tkWWWPanDeletePan [lindex $list 0]"

	DLG:set_entry_value $w 1 [lindex $list 2]
	DLG:set_entry_value $w 2 [lindex $list 1]
	.annotate_dialog.text insert 0.0 [lindex $list 3]

	DLG:show . $w
    }
}

## Create the annotation editor
proc tkWWWAnnotateCreateEditor {w command delete_command} {
    DLG:toplevel . $w
    DLG:draw_entries $w {"Annotation Author:" "Annotation Title:"}

    pack append $w \
	[label $w.label \
	   -text "Please type your comments below" ] { fillx top} \
	[text $w.text ] {expand fill top}

    DLG:draw_buttons $w [list "Annotate" "Delete" "Dismiss" "Help"]
    DLG:bind_button $w 1 "$command ; DLG:hide $w"
    DLG:bind_button $w 2 "$delete_command ; DLG:hide $w"
    DLG:bind_button $w 3 "DLG:hide $w"
    DLG:bind_button $w 4 "tkWWWHelpNoHelp"
}

## Display annotations 
proc tkWWWAnnotateDisplay {} {
    tkWWWPanDisplayAnnotations [tkWWWNavigateGetAddress]
}

