## font.tcl Procedures for changing fonts
## ==============
## Copyright (C) 1992 Joseph Wang
## See the file COPYRIGHT for conditions

## The procedures in this file are responsible for font display

## Conventions:
##   All procedures in this file begin with tkWWWFont

set tkWWWFontTimesFonts { \
    {"" "-adobe-times-medium-r-*-*-12-*-*-*-*-*-*-*"}
    {"Heading1" "-adobe-times-bold-r-normal-*-24-*-*-*-*-*-*-*"} 
    {"Heading2" "-adobe-times-bold-r-normal-*-18-*-*-*-*-*-*-*"} 
    {"Heading3" "-adobe-times-bold-r-normal-*-18-*-*-*-*-*-*-*"} 
    {"Heading4" "-adobe-times-bold-r-normal-*-14-*-*-*-*-*-*-*"} 
    {"Heading5" "-adobe-times-bold-r-normal-*-12-*-*-*-*-*-*-*"} 
    {"Heading6" "-adobe-times-bold-r-normal-*-12-*-*-*-*-*-*-*"} 
    {"Address" "-adobe-times-medium-i-normal-*-14-*-*-*-*-*-*-*"} 
    {"Listing" "-adobe-courier-medium-r-normal-*-12-*-*-*-*-*-*-*"}
    {"Example" "-adobe-courier-medium-r-normal-*-12-*-*-*-*-*-*-*"}
    {"Dir" "-adobe-courier-medium-r-normal-*-12-*-*-*-*-*-*-*"}
    {"Preformatted" "-adobe-courier-medium-r-normal-*-12-*-*-*-*-*-*-*"}
    {"Glossary" "-adobe-times-medium-r-*-*-12-*-*-*-*-*-*-*"}
    {"(Unstyled)" "-adobe-courier-medium-r-normal-*-12-*-*-*-*-*-*-*"}
}

set tkWWWFontHelveticaFonts { \
    {"" "-adobe-helvetica-medium-r-*-*-12-*-*-*-*-*-*-*"}
    {"Heading1" "-adobe-helvetica-bold-r-normal-*-24-*-*-*-*-*-*-*"} 
    {"Heading2" "-adobe-helvetica-bold-r-normal-*-18-*-*-*-*-*-*-*"} 
    {"Heading3" "-adobe-helvetica-bold-r-normal-*-18-*-*-*-*-*-*-*"} 
    {"Heading4" "-adobe-helvetica-bold-r-normal-*-14-*-*-*-*-*-*-*"} 
    {"Heading5" "-adobe-helvetica-bold-r-normal-*-12-*-*-*-*-*-*-*"} 
    {"Heading6" "-adobe-helvetica-bold-r-normal-*-12-*-*-*-*-*-*-*"} 
    {"Address" "-adobe-helvetica-medium-o-normal-*-14-*-*-*-*-*-*-*"} 
    {"Listing" "-adobe-courier-medium-r-normal-*-12-*-*-*-*-*-*-*"}
    {"Example" "-adobe-courier-medium-r-normal-*-12-*-*-*-*-*-*-*"}
    {"Dir" "-adobe-courier-medium-r-normal-*-12-*-*-*-*-*-*-*"}
    {"Glossary" "-adobe-helvetica-medium-r-*-*-12-*-*-*-*-*-*-*"}
    {"Preformatted" "-adobe-courier-medium-r-normal-*-12-*-*-*-*-*-*-*"}
    {"(Unstyled)" "-adobe-courier-medium-r-normal-*-12-*-*-*-*-*-*-*"}
}

set tkWWWFontNewCenturyFonts { \
    {"" "-adobe-new century schoolbook-medium-r-*-*-12-*-*-*-*-*-*-*"}
    {"Heading1" "-adobe-new century schoolbook-bold-r-normal-*-24-*-*-*-*-*-*-*"} 
    {"Heading2" "-adobe-new century schoolbook-bold-r-normal-*-18-*-*-*-*-*-*-*"} 
    {"Heading3" "-adobe-new century schoolbook-bold-r-normal-*-18-*-*-*-*-*-*-*"} 
    {"Heading4" "-adobe-new century schoolbook-bold-r-normal-*-14-*-*-*-*-*-*-*"} 
    {"Heading5" "-adobe-new century schoolbook-bold-r-normal-*-12-*-*-*-*-*-*-*"} 
    {"Heading6" "-adobe-new century schoolbook-bold-r-normal-*-12-*-*-*-*-*-*-*"} 
    {"Address" "-adobe-new century schoolbook-medium-i-normal-*-14-*-*-*-*-*-*-*"} 
    {"Listing" "-adobe-courier-medium-r-normal-*-12-*-*-*-*-*-*-*"}
    {"Example" "-adobe-courier-medium-r-normal-*-12-*-*-*-*-*-*-*"}
    {"Dir" "-adobe-courier-medium-r-normal-*-12-*-*-*-*-*-*-*"}
    {"Preformatted" "-adobe-courier-medium-r-normal-*-12-*-*-*-*-*-*-*"}
    {"Glossary" "-adobe-new century schoolbook-medium-r-*-*-12-*-*-*-*-*-*-*"}
    {"(Unstyled)" "-adobe-courier-medium-r-normal-*-12-*-*-*-*-*-*-*"}
}

set tkWWWFontLucidaFonts { \
    {"" "-b&h-lucida-medium-r-*-*-12-*-*-*-*-*-*-*"}
    {"Heading1" "-b&h-lucida-bold-r-normal-*-24-*-*-*-*-*-*-*"} 
    {"Heading2" "-b&h-lucida-bold-r-normal-*-18-*-*-*-*-*-*-*"} 
    {"Heading3" "-b&h-lucida-bold-r-normal-*-18-*-*-*-*-*-*-*"} 
    {"Heading4" "-b&h-lucida-bold-r-normal-*-14-*-*-*-*-*-*-*"} 
    {"Heading5" "-b&h-lucida-bold-r-normal-*-12-*-*-*-*-*-*-*"} 
    {"Heading6" "-b&h-lucida-bold-r-normal-*-12-*-*-*-*-*-*-*"} 
    {"Address" "-b&h-lucida-medium-i-normal-*-14-*-*-*-*-*-*-*"} 
    {"Listing" "-adobe-courier-medium-r-normal-*-12-*-*-*-*-*-*-*"}
    {"Example" "-adobe-courier-medium-r-normal-*-12-*-*-*-*-*-*-*"}
    {"Dir" "-adobe-courier-medium-r-normal-*-12-*-*-*-*-*-*-*"}
    {"Preformatted" "-adobe-courier-medium-r-normal-*-12-*-*-*-*-*-*-*"}
    {"Glossary" "-b&h-lucida-medium-r-*-*-12-*-*-*-*-*-*-*"}
    {"(Unstyled)" "-adobe-courier-medium-r-normal-*-12-*-*-*-*-*-*-*"}
}

proc tkWWWFontSetTextFonts {w list} {
    foreach font $list {
	set style [lindex $font 0]
	if {$style == ""} {
	    $w configure -font [lindex $font 1]
	} else {
	    $w tag configure $style -font [lindex $font 1]
	}
    }
    $w tag configure Anchor -underline true
}

proc tkWWWFontInitialize {} {
    global tkWWWFontTimesFonts
    global tkWWWFontHelveticaFonts
    global tkWWWFontNewCenturyFonts
    global tkWWWFontLucidaFonts

    set list {
	{tkWWWFontTimesFonts "Times (Default)"}
	{tkWWWFontHelveticaFonts "Helvetica"}
	{tkWWWFontNewCenturyFonts "New Century Schoolbook"}
	{tkWWWFontLucidaFonts "Lucida Bright"}
    }
    DLG:toplevel . .font_dialog
    pack append .font_dialog \
	[frame .font_dialog.f] top 
    foreach item $list {
	pack append .font_dialog.f \
	    [radiobutton .font_dialog.f.[lindex $item 0] \
	     -text [lindex $item 1] -relief flat \
		 -variable font_name \
                 -anchor w ] {top fillx}
    }
    DLG:draw_buttons .font_dialog  {"OK" "Apply" "Cancel"}

    DLG:bind_button .font_dialog 1 \
	"tkWWWFontSetTextFonts .f.msg \[set \$font_name\]
DLG:hide .font_dialog"
    DLG:bind_button .font_dialog 2 \
	"tkWWWFontSetTextFonts .f.msg \[set \$font_name\]"
    DLG:bind_button .font_dialog 3 "DLG:hide .font_dialog"

    tkWWWFontSetTextFonts .f.msg $tkWWWFontTimesFonts
}
	
	
    
