## help.tcl tkWWW help facility
## ==============
## Copyright (C) 1992 Joseph Wang
## See the file COPYRIGHT for conditions

## Conventions:
##   all global visible objects in this file should begin with 
##   tkWWWHelp

proc tkWWWHelpInitialize {} {
    tkWWWHelpCreateWhineDialog . .send_mail_dialog

}

proc tkWWWHelpCreateWhineDialog {parent w} {
    global tkWWWVersion

    DLG:toplevel . $w
    DLG:draw_entries $w {To: Subject:}
    DLG:set_entry_value $w 1 "tk-www-bugs@athena.mit.edu"
    DLG:set_entry_value $w 2 "Comments on tkWWW Version $tkWWWVersion"
    
    pack append $w \
	[label $w.label \
	   -text "Please type your comments below" ] { fillx top} \
	[text $w.text ] {expand fill top}

    DLG:draw_buttons $w [list "Send Mail" "Dismiss" "Help"]
    DLG:bind_button $w 1 "wm withdraw $w ; 
    tkWWWConfigSendMail \
        \[DLG:get_entry_value $w 1\] \[DLG:get_entry_value $w 2\] \
        \[$w.text get 0.0 end\]"

    DLG:bind_button $w 2 "DLG:hide $w"
    DLG:bind_button $w 3 "tkWWWHelpNoHelp"
}

proc tkWWWHelpNotAvailable {} {
    DLG:information . .not_available \
	"Sorry: This feature is not available yet" "OK"
}

proc tkWWWHelpAddToMailingList {} {
    tkWWWOutputSetMessage "Sending request to tk-www-request@athena.mit.edu"
    tkWWWConfigSendMail tk-www-request@athena.mit.edu "Subscribe" "Add to list"
    tkWWWOutputSetMessage "Request sent to tk-www-request@athena.mit.edu"
}

proc tkWWWHelpRemoveFromMailingList {} {
    tkWWWOutputSetMessage "Sending request to tk-www-request@athena.mit.edu"
    tkWWWConfigSendMail tk-www-request@athena.mit.edu "Remove" "Remove from list"
    tkWWWOutputSetMessage "Request sent to tk-www-request@athena.mit.edu"
}

proc tkWWWHelpGetTopic {topic} {
    if {$topic != "no_help"} {
	global tkWWWConfigHelpRoot
	tkWWWNavigateClone $tkWWWConfigHelpRoot/$topic.html
    } {
	DLG:information . .no_help \
	    "Sorry: No help is available on this topic yet" "OK"
    }
}
