/**/## tkWWW.tcl main file for tkWWW  user interface
/**/## ==============
/**/## Copyright (C) 1992 Joseph Wang
/**/## See the file COPYRIGHT for conditions 

/**/## *************************
/**/## This is the directory containing the source code
/**/## *************************

set tkWWWSourcePath CPP_TK_WWW_SOURCE_PATH

/**/## *************************
/**/## end of user defined parameters
/**/## *************************

source $tkWWWSourcePath/config.tcl

/**/## *************************
/**/## source user configuration file
/**/## *************************

if [file exists [glob "~/.tkwww-config"]] {
  	source [glob "~/.tkwww-config"]
}

set tkWWWVersion "0.8"

/**/# Forbid rename for security sake
rename rename ""

/**/# Add the source path to the auto load table
set auto_path "$tkWWWSourcePath $auto_path"

/**/## *************************
/**/## Parse the command line
/**/## *************************

tkWWWParseArgs $argv

/**/## *************************
/**/## Startup the server
/**/## Do this early do that the server has time to "warm up" 
/**/## before we actually use it
/**/## *************************

tkWWWServerOpen $tkWWWServerCommand "tkWWW:"

/**/# ************************
/**/# Check for incompatibilties between frontend and backend
/**/# ************************

tkWWWVersionVerify $tkWWWVersion

/**/# *************************
/**/# Window management and Interface code 
/**/# *************************
wm title . "tkWWW"
wm minsize . 0 0
wm iconbitmap . @$tkWWWSourcePath/bitmap/logo


pack append . \
    [ tkWWWMenuMakeMenus .menu $tkWWWConfigMenus ] {top fillx} \
    [ tkWWWOutputMakeTitleBox .titles ] {top fillx} \
    [ tkWWWOutputMakeText .f ] {top expand fill } \
    [ tkWWWOutputMakeButtons .buttons $tkWWWConfigButtons ] {top fillx} \
    [ tkWWWOutputMakeToggles .toggles $tkWWWConfigToggles ] {top fillx} 

tkWWWOutputMakeScrollbars

/**/## *************************
/**/## Do initializations
/**/## *************************

tkWWWNavigateInitialize
tkWWWFontInitialize
tkWWWFileInitialize
tkWWWEditInitialize
tkWWWHistoryInitialize
tkWWWPanInitialize
tkWWWHelpInitialize
tkWWWBookmarksInitialize
FSBoxInitialize

/**/## *************************
/**/## GUI is created
/**/## Set the welcome message and
/**/## Jump to the first page
/**/## *************************

if {$tkWWWParseArgsShowInfo != 0} {
	tkWWWFileAboutTkWWW
}
tkWWWNavigateGoto $tkWWWStartPage
