## parse_args.tcl - Parse command line arguments
## ==============
## Copyright (C) 1992 Joseph Wang
## See the file COPYRIGHT for conditions

set tkWWWParseArgsShowInfo 1

## tkWWWParseArgs: Parse arguments
## ----------
## On entry,
##   argv: command line to parse
## On exit,
##   none
## Side effects,
##   Resets various internal variables 

proc tkWWWParseArgs {argv} {
   global tkWWWStartPage
   global tkWWWHomePage
   global tkWWWParseArgsShowInfo
   set argc [llength $argv]
   for {set tkWWWCounter 0} {$tkWWWCounter < $argc} { incr tkWWWCounter 1} {
      case [string tolower [lindex $argv $tkWWWCounter]] in {
        {-wwwhome} {
            incr tkWWWCounter
            if {$tkWWWCounter < $argc} {
               set tkWWWHomePage [lindex $argv $tkWWWCounter]
            }
        }
        {-wwwstart} {
            incr tkWWWCounter
            if {$tkWWWCounter < $argc} {
               set tkWWWStartPage [lindex $argv $tkWWWCounter]
            }
        }
	{-wwwnoinfo} {
	    incr tkWWWCounter
	    set tkWWWParseArgsShowInfo 0
	}
	{-wwwiconic} {
            incr tkWWWCounter
	    wm iconify .
	}
	{-wwwiconpos} {
	    incr tkWWWCounter
	    if {$tkWWWCounter < $argc} {
		set x [lindex $argv $tkWWWCounter]
		incr tkWWWCounter
		wm iconpos . $x [lindex $argv $tkWWWCounter]
	    }
	}
	{-wwwgeometry} {
	    incr tkWWWCounter
            if {$tkWWWCounter < $argc} {
		wm geometry . [lindex $argv $tkWWWCounter]
	   }
	}
        {-wwwhelp} {
            puts stdout "\
Arguments:
   -wwwhome = Set the home page
   -wwwstart = Set the start page
   -wwwnoinfo = Start up tkWWW without showing the info window
   -wwwiconic = Start up tkWWW in iconic mode
   -wwwiconpos x y = Set tkWWW icon position
   -wwwgeometry = Set tkWWW geometry
"
            exit
        }
    }
  }
}
