## version.tcl - Verify version of the server
## ==============
## Copyright (C) 1992 Joseph Wang
## See the file COPYRIGHT for conditions

## This is the string that is displayed by About tkWWW

set tkWWWVersionAboutTkWWWString "TkWWW Version $tkWWWVersion\n\
by Joseph Wang (joe@athena.mit.edu)\n\
Copyright \251 1992-1993 Joseph Wang
Under the terms of the GNU Public License Version 2.0\n\
\n\
The tk-www mailing list is tk-www@athena.mit.edu\n\
Send subscription requests to tk-www-request@athena.mit.edu\n\
Send bugs to tk-www-bugs@athena.mit.edu"

## tkWWWVersionVerify: Verify the version of the server
## ----------

proc tkWWWVersionVerify {version} {
    global tkWWWServer

    set server_version [tkWWWServerSend "HtVersion"]
    if ![regexp {^([0-9]+).([0-9]+)} $server_version version_num major minor] {
	puts stderr "Warning: Cannot find version of tkWWW.server"
	return;
    }
    if {$major==0 && $minor < 8} {
	puts stderr \
"Error: tkWWW frontend is incompatible with tkWWW.server\n\
frontend version: $version  server version: $server_version\n\
You must recompile the tkWWW.server"
      exit 1
   }
   if {$version_num != $version} {
      puts stderr \
"Warning: Frontend version is different from server version\n\
frontend version: $version  server version: $server_version"
   }
}     
