/*
 * Copyright 1990 Pei-Yuan Wei.	All rights reserved.
 *
 * Permission to use, copy, and/or distribute for any purpose and
 * without fee is hereby granted, provided that both the above copyright
 * notice and this permission notice appear in all copies and derived works.
 * Fees for distribution or use of this software or derived works may only
 * be charged with express written permission of the copyright holder.
 * This software is provided ``as is'' without express or implied warranty.
 */
/*
 * class	: XBMButton
 * superClass	: XBM
 */
#include <stdio.h>
#include <ctype.h>
#include "error.h"
#include "mystrings.h"
#include "hash.h"
#include "ident.h"
#include "obj.h"
#include "packet.h"
#include "class.h"
#include "slotaccess.h"
#include "classlist.h"
#include "cl_XBMButton.h"
#include "misc.h"
#include "glib.h"
#include "event.h"

SlotInfo cl_XBMButton_NCSlots[] = {
	NULL
};
SlotInfo cl_XBMButton_NPSlots[] = {
	NULL
};
SlotInfo cl_XBMButton_CSlots[] = {
{
	STR_class,
	PTRS | SLOT_RW,
	(long)"XBMButton"
},{
	STR_classScript,
	PTRS,
	(long)"\n\
		switch (arg[0]) {\n\
		case \"mouseMove\":\n\
		case \"enter\":\n\
		case \"leave\":\n\
		case \"keyPress\":\n\
		case \"keyRelease\":\n\
		break;\n\
		case \"buttonPress\":\n\
			smudge();\n\
		break;\n\
		case \"buttonRelease\":\n\
			clean();\n\
		break;\n\
		case \"expose\":\n\
		case \"render\":\n\
			render();\n\
		break;\n\
		case \"config\":\n\
			config(arg[1], arg[2], arg[3], arg[4]);\n\
			render();\n\
		break;\n\
		case \"init\":\n\
			initialize();\n\
		break;\n\
		case \"info\":\n\
			info();\n\
		break;\n\
		case \"interpret\":\n\
			interpret(arg[1]);\n\
		break;\n\
		default:\n\
			print(\"unknown message, clsss = XBMButton: args: \");\n\
			for (i =0; i < arg[]; i++) print(arg[i], \", \");\n\
			print(\"\\n\");\n\
			break;\n\
		}\n\
	",
},{
	NULL
}
};
SlotInfo cl_XBMButton_PSlots[] = {
{
	STR__classInfo,
	CLSI,
	(long)&class_XBMButton
},{
	NULL
}
};

SlotInfo *slots_XBMButton[] = {
	(SlotInfo*)cl_XBMButton_NCSlots,
	(SlotInfo*)cl_XBMButton_NPSlots,
	(SlotInfo*)cl_XBMButton_CSlots,
	(SlotInfo*)cl_XBMButton_PSlots
};

MethodInfo meths_XBMButton[] = {
	/* local methods */
{
	STR_render,
	meth_XBMButton_render
},{
	NULL
}
};

ClassInfo class_XBMButton = {
	slots_XBMButton,	/* class slot information	*/
	meths_XBMButton,	/* class methods		*/
	STR_XBMButton,		/* class identifier number	*/
	&class_XBM,		/* super class info		*/
};

int meth_XBMButton_render(self, result, argc, argv)
	VObj *self;
	Packet *result;
	int argc;
	Packet argv[];
{
	return meth_XBM_render(self, result, argc, argv);
}








