/*
 * method.c
 */
/*
 * Copyright 1990 Pei-Yuan Wei.	All rights reserved.
 *
 * Permission to use, copy, and/or distribute for any purpose and
 * without fee is hereby granted, provided that both the above copyright
 * notice and this permission notice appear in all copies and derived works.
 * Fees for distribution or use of this software or derived works may only
 * be charged with express written permission of the copyright holder.
 * This software is provided ``as is'' without express or implied warranty.
 */
#include <stdio.h>
#include "hash.h"
#include "obj.h"
#include "packet.h"
#include "class.h"
#include "cexec.h"
#include "slotaccess.h"

/* 
 * optimization for later... use a hash table to hash unique method str id's.
 * the value of the hash node is an dispatch array, according to 
 * class-offset-id, of pointers to each class's method... thus, the only
 * search required is in the hashing to get the dispatch array.
 */
/*
 * for now, just dumbly search... 
 */ 
long callMeth(self, result, argc, argv, fid)
	VObj *self;
	Packet *result;
	int argc;
	Packet argv[];
	int fid;
{
	ClassInfo *cip;
	MethodInfo *mip;

	for (cip = GET__classInfo(self); cip; cip = cip->superClass) {
		for (mip = cip->methods; mip->id; mip++) {
			if (mip->id == fid) {
				((long (*)())(mip->method))
						(self, result, argc, argv);
				return 1;
			}
		}
	}
	return 0;
}
